unit KWARD_Consts;

interface

uses
  Winapi.Windows;

const
  x86StateID = '{0DB5EAD5-307F-40B7-9242-D529112A2F34}';
  x64StateID = '{E4922840-7124-4DCE-A41A-DEA713EA4554}';

function IsRunning(StateID: string): Boolean;

implementation

function IsRunning(StateID: string): Boolean;
var
  Mutex: THandle;
begin
  Mutex := OpenMutex(MUTEX_ALL_ACCESS, False, PChar(StateID));
  Result := Mutex <> 0;
  CloseHandle(Mutex);
end;

end.
