(* Kana Ward

Ver, 0.90 2011/02/27 Imm ŊB
Ver, 0.91 2011/03/19 tbN~XCB
Ver, 0.92 2011/09/19 וB
Ver, 0.93 2012/04/28 R|[lg̕ύXƁAdNh~̕ύXB
Ver, 1.00 2016/09/12 וB Ver,1.00 łB
Ver, 1.01 2017/04/06 Delphi10.1 ɈڍsBvIȃ|J~XCB
Ver, 1.02 2017/12/24 CuXVBוB
Ver, 1.03 2019/01/06 Delphi10.2 ɈڍsBx64 ΉBTSF ΉiȂĂ݂jB
Ver, 1.04 2019/04/04 Delphi10.3 ɈڍsBWndProc XVBIvVXVB
Ver, 1.05 2021/04/10 dN}~@ύXB萔\[XB

  {͊Ď *)

program KanaWard;

uses
  Vcl.Forms,
  Winapi.Windows,
  Winapi.Messages,
  WndInfo,
  KWARD_Host in 'KWARD_Host.pas' {HostForm},
  KWARD_Consts in 'KWARD_Consts.pas';

{$R *.res}


var
  RunningState: THandle;

function EnumWindowsProc(hwnd: HWND; lParam: LPARAM): BOOL; stdcall;
begin
  if ('THostForm' = GetClassNameStr(hwnd)) and (ParamStr(0) = GetWindowFileName(hwnd)) then
  begin
    LPDWORD(lParam)^ := hwnd;
    Result := False;
  end
  else
    Result := True;
end;

procedure CloseRunningWindow;
var
  Wnd: HWND;
  i: Integer;
begin
  Wnd := 0;
  EnumWindows(@EnumWindowsProc, LPARAM(@Wnd));
  if Wnd <> 0 then
  begin
    SendMessage(Wnd, WM_CLOSE, 0, 0);
    for i := 0 to 50 do
    begin
      Sleep(100);
      if not IsRunning(x86StateID) then
        Break;
    end;
  end;
end;

begin
  {$IFDEF DEBUG}
  ReportMemoryLeaksOnShutdown := True;
  {$ENDIF DEBUG}
  //dN}~
  if IsRunning(x86StateID) then
  begin
    {$IFDEF DEBUG}
    OutputDebugString('KWARD: RebootX86');
    {$ENDIF DEBUG}
    CloseRunningWindow;
  end;
  //N
  RunningState := CreateMutex(nil, False, PChar(x86StateID));
  if RunningState <> 0 then
  begin
    try
      if GetLastError <> ERROR_ALREADY_EXISTS then
      begin
        Application.Initialize;
        Application.MainFormOnTaskbar := True;
        Application.CreateForm(THostForm, HostForm);
        Application.Run;
      end
      else
        MessageBox(0, 'Mutex already exists', 'Kana Ward', MB_OK or MB_ICONERROR);
    finally
      CloseHandle(RunningState);
    end;
  end
  else
    MessageBox(0, 'Mutex creation failed', 'Jerboa', MB_OK or MB_ICONERROR);
end.
