(* Kana Ward

Ver, 1.03 2019/01/06 قɍ킹 Ver,1.03 JnB
Ver, 1.04 2019/04/04 Delphi10.3 ɈڍsBtbNtH[ɈړiςȂjB
Ver, 1.05 2021/04/10 dN}~@ύXB

  {͊Ď *)

program KanaWard.x64;

uses
  Vcl.Forms,
  System.SysUtils,
  Winapi.Windows,
  Winapi.ShellAPI,
  KWARD_Escort in 'KWARD_Escort.pas' {EscortForm},
  KWARD_Consts in 'KWARD_Consts.pas';

{$R *.res}

var
  RunningState: THandle;

function x86FileName: string;
begin
  Result := ChangeFileExt(ChangeFileExt(ParamStr(0), ''), '.exe');
end;

begin
  {$IFDEF DEBUG}
  ReportMemoryLeaksOnShutdown := True;
  {$ENDIF DEBUG}
  //N`FbN
  if not IsRunning(x86StateID) or IsRunning(x64StateID) then
  begin
    {$IFDEF DEBUG}
    OutputDebugString('KWARD: RebootX64');
    {$ENDIF DEBUG}
    ShellExecute(0, 'open', PChar(x86FileName), '', '', SW_SHOWNORMAL);
  end
  else
  begin
    RunningState := CreateMutex(nil, False, PChar(x64StateID));
    if RunningState <> 0 then
    begin
      try
        if GetLastError <> ERROR_ALREADY_EXISTS then
        begin
          Application.Title := 'KanaWard.x64';
          Application.Initialize;
          Application.MainFormOnTaskbar := True;
          Application.CreateForm(TEscortForm, EscortForm);
          Application.Run;
        end
        else
          MessageBox(0, 'Mutex already exists', 'Kana Ward (x64)', MB_OK or MB_ICONERROR);
      finally
        CloseHandle(RunningState);
      end;
    end
    else
      MessageBox(0, 'Mutex creation failed', 'Kana Ward (x64)', MB_OK or MB_ICONERROR);
  end;
end.
